#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

int main(int argc, char *argv[]) {
  int fd;
  mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
  char filename[4096];
  int *buf;
  int curr_pattern, tmp_bit, start_pattern;
  int i, j;
  int num_blks, pattern_seed, blk_size;

  //get input  
  if (argc < 5) {
    printf("Usage: %s <size of block (multiple of 512)> <num_blks> <filename> <pattern_seed>\n", argv[0]);
    exit (0);
      
  }
  blk_size = atoi(argv[1]);
  num_blks = atoi(argv[2]);
  strcpy(filename, argv[3]);
  pattern_seed = atoi(argv[4]);

  //open file
  curr_pattern = pattern_seed;
  start_pattern = curr_pattern;
  fd = open(filename, O_WRONLY | O_CREAT | O_TRUNC, mode);

  //Malloc buffer
  buf = (int *) malloc(blk_size * num_blks);

  //Fill buffer (assume int is 32 bits!!)
  for (j=0; j<num_blks; j=j+1) {
    printf("Curr Pattern: %x \n", curr_pattern);
    for(i=0; i<(blk_size/4); i++){
      buf[i + j*(blk_size/4)] = curr_pattern;
      //buf[i] = curr_pattern;
    }      
    tmp_bit = curr_pattern & 0x80000000;
    curr_pattern = (curr_pattern << 1) | ((tmp_bit >> 31) & 0x00000001);
    if (curr_pattern == start_pattern) {
      curr_pattern = curr_pattern + 2;
      start_pattern = curr_pattern;
    }
    //write(fd, (void *) buf, blk_size);
    //fsync(fd);
  }

  //Write, sync, and close file
  write(fd, (void *) buf, blk_size*num_blks);
  fsync(fd);
  close(fd);

  free((void *) buf);
  
}
